diff -uwrN sourceold/CTF/CTF.cpp source/CTF/CTF.cpp
--- sourceold/CTF/CTF.cpp	2012-04-14 04:09:52.823242100 +0800
+++ source/CTF/CTF.cpp	2012-07-28 09:12:13.661132800 +0800
@@ -749,6 +749,7 @@
 	{
 		StringClass str;
 		str.Format("msg Running in Capture The Flag mode. This rounds CTF class will be '%s' with a capture limit of %d.",ctf.mapConfiguration.CTFClassName.Peek_Buffer(),ctf.mapConfiguration.CTFCapLimit);
+		Console_Input(str);
 		if (ctf.mapConfiguration.CTFReverse)
 		{
 			Console_Input("msg This is a Reverse CTF game. Your objective is to take the enemy flag from your base and run it to your pedestal in the enemy base.");
diff -uwrN sourceold/crates/crates.cpp source/crates/crates.cpp
--- sourceold/crates/crates.cpp	2012-04-24 13:41:43.463867100 +0800
+++ source/crates/crates.cpp	2012-07-31 23:11:18.530273400 +0800
@@ -443,7 +443,7 @@
 					Console_Input(msg);
 					Vector3	pos;
 					pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;DEATH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;DEATH;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateTiberium)) && (crate.mapConfiguration.CrateTiberium >	0)) {
 					message2.Format("%ls picked up a Tiberium Death crate.",Get_Wide_Player_Name(sender));
@@ -453,7 +453,7 @@
 					message1.Format("ppage %d [Crate] You have been killed by the tiberium death crate and your remains mutated into a visceroid.",Get_Player_ID(sender));
 					Commands->Create_2D_WAV_Sound("m00evag_dsgn0027i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;TIBERIUMDEATH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;TIBERIUMDEATH;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateAmmo)) && (crate.mapConfiguration.CrateAmmo > 0)) {
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
@@ -464,7 +464,7 @@
 					message1.Format("ppage %d [Crate] You just got the Full Ammo Crate, your ammo has been refilled.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;FULLAMMO;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;FULLAMMO;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateArmor)) && (crate.mapConfiguration.CrateArmor > 0)) {
 					int	RndGood	= Commands->Get_Random_Int(1,3);
@@ -474,14 +474,14 @@
 						message2.Format("%ls picked up an Armor crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Armor Crate, your max armor has been increased!",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
-						message3.Format("CRATE;ARMORINCREASE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+						message3.Format("CRATE;ARMORINCREASE;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Commands->Set_Shield_Strength(sender,1);
 						message2.Format("%ls picked up a Dearmor crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Dearmor Crate, your armor has been set to 1.",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
-						message3.Format("CRATE;ARMORLOST;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+						message3.Format("CRATE;ARMORLOST;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateHealth)) &&	(crate.mapConfiguration.CrateHealth >	0)) {
@@ -492,7 +492,7 @@
 						message2.Format("%ls picked up a Health crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Health Crate, your max health has been increased!",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
-						message3.Format("CRATE;HEALTHUPGRADE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+						message3.Format("CRATE;HEALTHUPGRADE;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Commands->Set_Health(sender,1);
@@ -500,7 +500,7 @@
 						message1.Format("ppage %d [Crate] You just got the Dehealth Crate, your health has been set to 1.",Get_Player_ID(sender));
 						Create_2D_WAV_Sound_Player(sender,"m00evag_dsgn0026i1evag_snd.wav");
 						Vector3 pos = Commands->Get_Position(sender);
-						message3.Format("CRATE;HEALTHREDUCE;;%d;%s;%f;%f;%f;%f;%f;%f;%d",	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+						message3.Format("CRATE;HEALTHREDUCE;%d;%s;%f;%f;%f;%f;%f;%f;%d",	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateCharacter))	&& (crate.mapConfiguration.CrateCharacter	> 0)) {
@@ -554,7 +554,7 @@
 					message2.Format("%ls picked up the Butter Fingers crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You picked up the Butter Fingers Crate, you have dropped most of your weapons.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;BUTTERFINGER;;%d;%s;%f;%f;%f;%f;%f;%f;%d",Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;BUTTERFINGER;%d;%s;%f;%f;%f;%f;%f;%f;%d",Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateRefill)) &&	(crate.mapConfiguration.CrateRefill >	0)) {
 					Grant_Refill(sender);
@@ -562,7 +562,7 @@
 					message1.Format("ppage %d [Crate] You just got the Refill Crate, your health, armor, and ammo have all been refilled.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;REFILL;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;REFILL;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateBeacon)) &&	(crate.mapConfiguration.CrateBeacon >	0)) {
 					if (DisableBeacons) {
@@ -584,7 +584,7 @@
 							Create_2D_Sound_Player(sender,"m00evan_dsgn0074i1evan_snd.wav");
 						}
 						Vector3	pos	= Commands->Get_Position(sender);
-						message3.Format("CRATE;BEACON;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+						message3.Format("CRATE;BEACON;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Commands->Create_Object("Beacon_Nuke_Strike_Anim_Post",Commands->Get_Position(obj));
@@ -598,7 +598,7 @@
 						delete[] str;
 						Console_Input(msg);
 						Vector3	pos	= Commands->Get_Position(sender);
-						message3.Format("CRATE;BEACONDEATH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender),	pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+						message3.Format("CRATE;BEACONDEATH;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender),	pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateSpy)) && (crate.mapConfiguration.CrateSpy > 0)) {
@@ -616,14 +616,14 @@
 					delete[] str2;
 					Console_Input(msg);
 					Vector3 pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;SPY;;0;0;%f;%f;%f;%f;%f;%f;%d",pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;SPY;0;0;%f;%f;%f;%f;%f;%f;%d",pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateStealth)) && (crate.mapConfiguration.CrateStealth	> 0)) {
 					Commands->Enable_Stealth(sender,true);
 					message2.Format("%ls picked up a Stealth crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the stealth crate! You have been given a stealth suit.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;STEALTH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender),	pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;STEALTH;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender),	pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateThief))	&& (crate.mapConfiguration.CrateThief	> 0)) {
 					Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
@@ -631,7 +631,7 @@
 					message1.Format("ppage %d [Crate] You got the Thief Crate, you have lost all of your credits.",Get_Player_ID(sender));
 					Create_2D_Sound_Player(sender,"m00evag_dsgn0028i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;THIEF;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;THIEF;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateAmmoRegen))	&& (crate.mapConfiguration.CrateAmmoRegen	> 0)) {
 					Commands->Send_Custom_Event(obj,sender,100100,1,1);//enable regeneration of ammo on player
@@ -639,7 +639,7 @@
 					message1.Format("ppage %d [Crate] You got the Ammo Reneration Crate, your ammo will be refilled every minute.",Get_Player_ID(sender));
 					Create_2D_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");//ammo regen sound
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;AMMOREGEN;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;AMMOREGEN;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateHumanSilo))	&& (crate.mapConfiguration.CrateHumanSilo	> 0)) {
 					int team = Commands->Get_Player_Type(sender);
@@ -648,14 +648,14 @@
 					message1.Format("ppage %d [Crate] You got the Human Silo Crate, your entire team will be granted an additional $1 credit a second until you die or change character.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Team("m00pc$$_aqob0002i1evag_snd.wav",team);//credits acquired
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;HUMANSILO;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;HUMANSILO;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateUberWire))	&& (crate.mapConfiguration.CrateUberWire	> 0)) {
 					char ubermsg[250]; sprintf(ubermsg,"[CRATE] %s got the UberWire crate! Beware!",Get_Player_Name(sender)); Send_Message(255,255,255,ubermsg);
 					message2.Format("%ls picked up a UberWire crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the UberWire crate.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
-					message3.Format("CRATE;UBERWIRE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
+					message3.Format("CRATE;UBERWIRE;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					Change_Character(sender,"GDI_Engineer_2SF");
 				}
 				else {
diff -uwrN sourceold/scripts/CollisionMath.h source/scripts/CollisionMath.h
--- sourceold/scripts/CollisionMath.h	2012-04-14 04:09:47.768554600 +0800
+++ source/scripts/CollisionMath.h	2012-07-28 09:11:05.585937500 +0800
@@ -53,6 +53,14 @@
 		posfarpt->Z = -extent.Z;
 	}
 }
+
+inline void get_far_extent_branchless(const Vector3& normal, const Vector3& extent, Vector3* posfarpt)
+{
+	*reinterpret_cast<int*>(&posfarpt->X) = (*(reinterpret_cast<const int*>(&extent.X))) ^ ((*(reinterpret_cast<const int*>(&normal.X))) & 0x80000000);
+	*reinterpret_cast<int*>(&posfarpt->Y) = (*(reinterpret_cast<const int*>(&extent.Y))) ^ ((*(reinterpret_cast<const int*>(&normal.Y))) & 0x80000000);
+	*reinterpret_cast<int*>(&posfarpt->Z) = (*(reinterpret_cast<const int*>(&extent.Z))) ^ ((*(reinterpret_cast<const int*>(&normal.Z))) & 0x80000000);
+}
+
 class SHADERS_API CollisionMath
 {
 public:
@@ -104,7 +112,7 @@
 	{
 		Vector3 posfarpt;
 		Vector3 negfarpt;
-		get_far_extent(plane.N,box.Extent,&posfarpt);
+		get_far_extent_branchless(plane.N,box.Extent,&posfarpt);
 		negfarpt = -posfarpt;
 		posfarpt += box.Center;
 		negfarpt += box.Center;
@@ -159,36 +167,7 @@
 	static OverlapType	Overlap_Test(const FrustumClass & frustum,const SphereClass & sphere);
 	static OverlapType	Overlap_Test(const FrustumClass & frustum,const AABoxClass & box);
 	static OverlapType	Overlap_Test(const FrustumClass & frustum,const OBBoxClass & box);
-	static OverlapType	Overlap_Test(const FrustumClass & frustum,const AABoxClass & box,int & planes_passed)
-	{
-		int mask = 0;
-		for (int i = 0; i < 6; i++)
-		{
-			int plane_bit = (1<<i);
-			if ((planes_passed & plane_bit) == 0)
-			{
-				int result = CollisionMath::Overlap_Test(frustum.Planes[i],box);
-				if (result == OUTSIDE)
-				{
-					return OUTSIDE;
-				}
-				else if (result == INSIDE)
-				{
-					planes_passed |= plane_bit;
-				}
-				mask |= result;
-			}
-			else
-			{
-				mask |= INSIDE;
-			}
-		}
-		if (mask == INSIDE)
-		{
-			return INSIDE;
-		}
-		return OVERLAPPED;
-	}
+	static OverlapType	Overlap_Test(const FrustumClass & frustum,const AABoxClass & box,int & planes_passed);
 	static OverlapType	Overlap_Test(const FrustumClass & frustum,const OBBoxClass & box,int & planes_passed);
 
 	static OverlapType	Overlap_Test(const Vector3 & min,const Vector3 & max,const LineSegClass & line)
diff -uwrN sourceold/scripts/ConnectionRequest.h source/scripts/ConnectionRequest.h
--- sourceold/scripts/ConnectionRequest.h	2012-04-14 04:09:47.994140600 +0800
+++ source/scripts/ConnectionRequest.h	2012-07-28 09:11:06.683593700 +0800
@@ -25,5 +25,6 @@
 	uint32 clientExeKey;
 	StringClass clientSerialHash;
 	float clientVersion;
+	uint clientRevisionNumber;
 	WideStringClass password;
 };
diff -uwrN sourceold/scripts/Defines.h source/scripts/Defines.h
--- sourceold/scripts/Defines.h	2012-04-14 04:09:46.789062500 +0800
+++ source/scripts/Defines.h	2012-08-21 12:41:46.200195300 +0800
@@ -16,7 +16,7 @@
 
 #include "Types.h"
 #include "stdarg.h"
-#if (WWCONFIG) || (TDBEDIT) || (W3DSHADER) || (W3DLIB_EXPORTS) || (W3DMESHMENDER) || (W3DDEPENDS) || (W3DMAPPER) || (ACHASH) || (PACKAGEEDITOR) || (FIXPLANES) || (MERGELOD) || (MIXCHECK) || (DDBEDIT) || (MAKEMIX)
+#if (WWCONFIG) || (TDBEDIT) || (W3DSHADER) || (W3DLIB_EXPORTS) || (W3DMESHMENDER) || (W3DDEPENDS) || (W3DMAPPER) || (ACHASH) || (PACKAGEEDITOR) || (FIXPLANES) || (MERGELOD) || (MIXCHECK) || (DDBEDIT) || (MAKEMIX) || (ALTMAT)
 #define EXTERNAL 1
 #endif
 
@@ -38,6 +38,9 @@
 // breakpoint
 #define TT_INTERRUPT  { __asm { __asm int 3 } }
 
+// assert that is not removed in release mode
+#define TT_RELEASE_ASSERT(expression) { if (!(expression)) TT_INTERRUPT; }
+
 // assert
 #ifdef DEBUG
 #	define TT_ASSERT(expression) \
diff -uwrN sourceold/scripts/LineSegClass.h source/scripts/LineSegClass.h
--- sourceold/scripts/LineSegClass.h	2012-04-14 04:09:46.237304600 +0800
+++ source/scripts/LineSegClass.h	2012-08-12 22:45:46.237789100 +0800
@@ -25,6 +25,11 @@
 	{
 		recalculate();
 	}
+	LineSegClass(const Vector3& p0, const Vector3& dir, float l) : P0(p0), Dir(dir), Length(l)
+	{
+		DP = Dir * Length;
+		P1 = P0 + DP;
+	}
 	LineSegClass(const LineSegClass & that,const Matrix3D & tm)
 	{
 		Set(that,tm);
@@ -35,6 +40,14 @@
 		P1 = p1;
 		recalculate();
 	}
+	void Set(const Vector3& p0, const Vector3& dir, float l)
+	{
+		DP = dir * l;
+		P0 = p0;
+		P1 = p0 + DP;
+		Dir = dir;
+		Length = l;
+	}
 	void					Set(const LineSegClass & that,const Matrix3D & tm);
 	void					Set_Random(const Vector3 & min,const Vector3 & max);
 	const Vector3 &	Get_P0() const
diff -uwrN sourceold/scripts/MeshClass.h source/scripts/MeshClass.h
--- sourceold/scripts/MeshClass.h	2012-04-14 04:09:48.142578100 +0800
+++ source/scripts/MeshClass.h	2012-08-26 23:52:06.549203100 +0800
@@ -95,10 +95,14 @@
 	unsigned							Get_Debug_Id() const { return  MeshDebugId; }
 	void								Set_Debugger_Disable(bool b) { IsDisabledByDebugger=b; }
 	bool								Is_Disabled_By_Debugger() const { return IsDisabledByDebugger; }
-	void								Install_User_Lighting_Array(Vector4 * lighting);
+	SHADERS_API void								Install_User_Lighting_Array(Vector4 * lighting);
 	unsigned int *					Get_User_Lighting_Array(bool alloc = false);
 	virtual void					Save_User_Lighting (ChunkSaveClass & csave);
-	virtual void					Load_User_Lighting (ChunkLoadClass & cload);
+	SHADERS_API virtual void					Load_User_Lighting (ChunkLoadClass & cload);
+
+	SHADERS_API void				Enable_Alternate_Material_Description(bool onoff);
+	SHADERS_API bool Use_User_Lighting(); //should this mesh have user lighting setup on it
+
 protected:
 	void								Free(void);
 	virtual void					Add_Dependencies_To_List (DynamicVectorClass<StringClass> &file_list, bool textures_only = false);
diff -uwrN sourceold/scripts/RenderObjClass.h source/scripts/RenderObjClass.h
--- sourceold/scripts/RenderObjClass.h	2012-04-14 04:09:47.270507800 +0800
+++ source/scripts/RenderObjClass.h	2012-08-27 13:03:47.565429700 +0800
@@ -267,6 +267,7 @@
    void							Validate_Cached_Bounding_Volumes(void)	const							{ Bits |= BOUNDING_VOLUMES_VALID; }
    void							Save_Sub_Object_User_Lighting(ChunkSaveClass & csave,RenderObjClass * sub_obj,int bone_index);
    void							Load_Sub_Object_User_Lighting(ChunkLoadClass & cload);
+   void Set_User_Lighting_Flag(); //Set the HAS_USER_LIGHTING flag appropriatly for this renderobj, intended to be called during vertex solve.
 }; // 0088  00A0
 TT_INLINE const SphereClass & RenderObjClass::Get_Bounding_Sphere(void) const
 {
diff -uwrN sourceold/scripts/ScriptZoneGameObj.h source/scripts/ScriptZoneGameObj.h
--- sourceold/scripts/ScriptZoneGameObj.h	2012-04-14 04:09:47.040039000 +0800
+++ source/scripts/ScriptZoneGameObj.h	2012-08-12 22:45:46.246578200 +0800
@@ -17,11 +17,14 @@
 #include "ScriptableGameObj.h"
 #include "OBBoxClass.h"
 class SmartGameObj;
+class RenderObjClass;
 class ScriptZoneGameObj : public ScriptableGameObj {
 private:
 	OBBoxClass BoundingBox;
 	int PlayerType;
 	SList<ReferencerClass> ZoneContents;
+
+	RenderObjClass* Model;
 public:
 	ScriptZoneGameObj();
 	~ScriptZoneGameObj();
@@ -31,6 +34,7 @@
 	const ScriptZoneGameObjDef SCRIPTS_API & Get_Definition( void ) const ;
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
+	void On_Post_Load();
 	void Think();
 	void Entered(PhysicalGameObj *);
 	bool In_List(PhysicalGameObj *);
diff -uwrN sourceold/scripts/ScriptZoneGameObjDef.h source/scripts/ScriptZoneGameObjDef.h
--- sourceold/scripts/ScriptZoneGameObjDef.h	2012-05-06 16:37:05.291906200 +0800
+++ source/scripts/ScriptZoneGameObjDef.h	2012-08-12 22:45:46.241695400 +0800
@@ -51,6 +51,9 @@
 	bool IsEnvironmentZone;
 	bool CheckC4;
 	int PresetID;
+
+	StringClass ModelName;
+
 	friend class ScriptZoneGameObj;
 	friend class PresetDump;
 };
diff -uwrN sourceold/scripts/SmartGameObj.h source/scripts/SmartGameObj.h
--- sourceold/scripts/SmartGameObj.h	2012-05-23 11:29:02.688476500 +0800
+++ source/scripts/SmartGameObj.h	2012-08-28 07:46:56.224609300 +0800
@@ -93,7 +93,7 @@
 	virtual float	Get_Stealth_Fade_Distance(void) const			{ return 25.0f; }
 	void				Grant_Stealth_Powerup(float seconds);
 	float				Remaining_Stealth_Powerup_Time(void);
-	StealthEffectClass * Peek_Stealth_Effect(void);
+	StealthEffectClass * Peek_Stealth_Effect(void) { return StealthEffect; }
 #ifndef TTLE_EXPORTS
 	static	float	Get_Global_Sight_Range_Scale( void )			{ return GlobalSightRangeScale; }
 	static	void	Set_Global_Sight_Range_Scale( float scale )	{ GlobalSightRangeScale = scale; }
diff -uwrN sourceold/scripts/TransitionGameObj.h source/scripts/TransitionGameObj.h
--- sourceold/scripts/TransitionGameObj.h	2012-05-23 11:15:26.267578100 +0800
+++ source/scripts/TransitionGameObj.h	2012-08-18 01:47:18.017578100 +0800
@@ -31,12 +31,12 @@
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
 	void On_Post_Load();
-	void Set_Transform(const Matrix3D &tm);
-	const Matrix3D &Get_Transform() const;
+	void Set_Transform(const Matrix3D &tm) {Transform = tm;}
+	const Matrix3D &Get_Transform() const {return Transform;}
 	void Create_Transitions();
 	void Destroy_Transitions();
 	void Update_Transitions();
-	void Set_Ladder_Index();
+	void Set_Ladder_Index(int index);
 	int Get_Transition_Count() {return Transitions.Count();};
 	TransitionInstanceClass *Get_Transition(int trans) {return Transitions[trans];}
 	int Get_Ladder_Index() {return LadderIndex;}
diff -uwrN sourceold/scripts/TransitionGameObjDef.h source/scripts/TransitionGameObjDef.h
--- sourceold/scripts/TransitionGameObjDef.h	2012-05-06 16:37:05.377843700 +0800
+++ source/scripts/TransitionGameObjDef.h	2012-08-18 01:56:17.041992100 +0800
@@ -37,6 +37,7 @@
 	}
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
+	StyleType Get_Type() {return Type;}
 }; // 0074
 
 class TransitionGameObjDef : public BaseGameObjDef {
@@ -54,7 +55,6 @@
 #ifdef DDBEDIT
 	virtual void                        Dump (FileClass &file);
 #endif
-	DECLARE_EDITABLE(TransitionGameObjDef,BaseGameObjDef);
 private:
 	DynamicVectorClass<TransitionDataClass *> Transitions;
 	friend class PresetDump;
diff -uwrN sourceold/scripts/TransitionInstanceClass.h source/scripts/TransitionInstanceClass.h
--- sourceold/scripts/TransitionInstanceClass.h	2012-04-14 04:09:46.772460900 +0800
+++ source/scripts/TransitionInstanceClass.h	2012-08-18 01:47:18.033203100 +0800
@@ -25,10 +25,10 @@
 	Matrix3D CharacterTransform; // 0000
 	OBBoxClass TriggerZone; // 0030
 	ReferencerClass Vehicle; // 006C
-	TransitionDataClass* Definition; // 007C
-	int LadderId; // 0080
+	const TransitionDataClass* Definition; // 007C
+	int LadderIndex; // 0080
 public:
-	TransitionInstanceClass();
+	TransitionInstanceClass(TransitionDataClass  const&);
 	~TransitionInstanceClass();
 	void Start(SoldierGameObj *soldier);
 	bool Check(SoldierGameObj *soldier, bool b);
@@ -36,6 +36,7 @@
 	void Set_Parent_Transform(Matrix3D const &tm);
 	TransitionDataClass::StyleType Get_Type() {return Definition->Type;}
 	void Set_Vehicle(VehicleGameObj *obj) {Vehicle = obj;}
+	void Set_Ladder_Index(int index) {LadderIndex = index;}
 }; // 0084
 
 #endif
\ No newline at end of file
diff -uwrN sourceold/scripts/VehicleGameObj.h source/scripts/VehicleGameObj.h
--- sourceold/scripts/VehicleGameObj.h	2012-04-14 04:09:46.375976500 +0800
+++ source/scripts/VehicleGameObj.h	2012-08-18 01:54:47.235351500 +0800
@@ -224,6 +224,8 @@
 	ReferencerClass     Owner; //Owner for SSGM vehicle locking. When this is set, only this player can enter the vehicle.
 	bool HasUpdatedTargeting;
 
+	void		Remove_Transitions( TransitionDataClass::StyleType transition_type );
+	void		Create_New_Transitions( TransitionDataClass::StyleType transition_type );
 	void		Destroy_Transitions( void );
 	void		Update_Transitions( void );
 	void		Create_And_Destroy_Transitions( void );
diff -uwrN sourceold/scripts/WWAudioClass.h source/scripts/WWAudioClass.h
--- sourceold/scripts/WWAudioClass.h	2012-04-14 04:09:47.830078100 +0800
+++ source/scripts/WWAudioClass.h	2012-08-04 10:17:08.598632800 +0800
@@ -266,20 +266,10 @@
 private:
 	static REF_DECL3(_theInstance,WWAudioClass *);
 	static HANDLE									_TimerSyncEvent;
-	typedef struct _CACHE_ENTRY_STRUCT
+	typedef struct _CACHE_ENTRY_STRUCT : public NoEqualsClass<_CACHE_ENTRY_STRUCT>
 	{
 		const char *					string_id;
 		SoundBufferClass *	buffer;
-		_CACHE_ENTRY_STRUCT (void)
-			: string_id (0), buffer (NULL) {}
-		_CACHE_ENTRY_STRUCT &operator= (const _CACHE_ENTRY_STRUCT &src)
-		{
-			string_id = _strdup (src.string_id);
-			REF_PTR_SET (buffer, src.buffer);
-			return *this;
-		}
-		bool operator== (const _CACHE_ENTRY_STRUCT &src) { return false; }
-		bool operator!= (const _CACHE_ENTRY_STRUCT &src) { return true; }
 	} CACHE_ENTRY_STRUCT;
 	typedef struct _LOGICAL_TYPE_STRUCT
 	{
diff -uwrN sourceold/scripts/cNetEvent.h source/scripts/cNetEvent.h
--- sourceold/scripts/cNetEvent.h	2012-05-23 11:02:14.050781200 +0800
+++ source/scripts/cNetEvent.h	2012-07-28 09:11:06.348632800 +0800
@@ -32,7 +32,7 @@
    virtual void Act             () = 0;
 
    void Init();
-   SCRIPTS_API void Set_Object_Dirty_Bit_For_Version(float version,DIRTY_BIT dirty_bit, bool onoff);
+   SCRIPTS_API void Set_Object_Dirty_Bit_For_Revision(uint revision,DIRTY_BIT dirty_bit, bool onoff);
 
 }; // 06B4
 
diff -uwrN sourceold/scripts/dllmain.cpp source/scripts/dllmain.cpp
--- sourceold/scripts/dllmain.cpp	2012-05-28 21:47:07.567382800 +0800
+++ source/scripts/dllmain.cpp	2012-08-24 20:46:44.369140600 +0800
@@ -388,6 +388,8 @@
 	Get_Mine_Limit = (gml)Address(tt,"Get_Mine_Limit");
 	Set_Special_Base_Destruction = (sbd)Address(tt,"Set_Special_Base_Destruction");
 	Get_Client_Version = (gpv)Address(tt,"Get_Client_Version");
+	Get_Client_Revision = (gpr)Address(tt,"Get_Client_Revision");
+	Get_Revision = (gpr)Address(tt,"Get_Revision");
 	Get_Damage_Warhead = (gdw)Address(tt,"Get_Damage_Warhead");
 	Commands->Action_Enter_Exit = (naee)Address(tt,"New_Action_Enter_Exit");
 	Get_GameObj_By_Player_Name = (ggobpn)Address(tt,"Get_GameObj_By_Player_Name");
@@ -407,6 +409,10 @@
 	Get_Client_Serial_Hash = (gcsh)Address(tt,"Get_Client_Serial_Hash");
 	Get_Tech_Level = (gml)Address(tt,"Get_Tech_Level");
 	Set_Tech_Level = (sw)Address(tt,"Set_Tech_Level");
+	Create_Explosion_Extended = (cee)Address(tt,"Create_Explosion_Extended");
+	Retrieve_Waypaths = (rwpa)Address(tt,"Retrieve_Waypaths");
+	Retrieve_Waypoints = (rwpo)Address(tt,"Retrieve_Waypoints");
+	Get_Waypoint_Position = (gwp)Address(tt,"Get_Waypoint_Position");
 	ssc ttssc = (ssc)Address(tt,"Set_Script_Commands");
 	ttssc(commands);
 #ifdef SSGM
